import java.util.Scanner;

/**
 * Created by leon on 2/9/18.
 */
public class MainApplication {
    Scanner input = new Scanner(System.in);
    BasicArithmetic baseMath = new BasicArithmetic();
    TrigFunctions trig = new TrigFunctions();   
    Memory memory = new Memory();
    Display display = new Display();
    double x = 0;
    public void calculator(){    
        System.out.println("Welcome to my calculator!\nEnter a number.");
        x = input.nextDouble();
        while(true){
            double displayNumber;
            System.out.println(x);
            System.out.print("Enter a command: ");
            String command = input.next();
            if (command.equalsIgnoreCase("exit")){
                System.out.println("Thanks for calculating with us!");
                break;
            }
            else if (command.equalsIgnoreCase("add")){
                double y = input.nextDouble();
                displayNumber = baseMath.add(x,y);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if (command.equalsIgnoreCase("subtract")){
                double y = input.nextDouble();
                displayNumber = baseMath.subtract(x,y);
                x = displayNumber;
                System.out.println(displayNumber);                
            }
            else if(command.equalsIgnoreCase("multiply")){
                double y = input.nextDouble();
                displayNumber = baseMath.multiply(x,y);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("divide")){
                double y = input.nextDouble();
                displayNumber = baseMath.divide(x,y);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("square")){
                displayNumber = baseMath.square(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("sqrt")){
                displayNumber = baseMath.squareRoot(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("exponentiation")){
                double y = input.nextDouble();
                displayNumber = baseMath.variableExponentiation(x,y);
                x = displayNumber;
                System.out.println(displayNumber);
            }    
            else if(command.equalsIgnoreCase("inverse")){
                displayNumber = baseMath.inverse(x);
                x = displayNumber;
                System.out.println(displayNumber);
            } 
            else if(command.equalsIgnoreCase("switchSigns")){
                displayNumber = baseMath.switchBetweenPositiveAndNegative(x);
                x = displayNumber;
                System.out.println(displayNumber);
            } 
            else if(command.equalsIgnoreCase("sine")){
                displayNumber = trig.sine(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("cosine")){
                displayNumber = trig.cosine(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("tangent")){
                displayNumber = trig.tangent(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("inverseSine")){
                displayNumber = trig.inverseSine(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("inverseCosine")){
                displayNumber = trig.inverseCosine(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("inverseTangent")){
                displayNumber = trig.inverseTangent(x);
                x = displayNumber;
                System.out.println(displayNumber);
            }
            else if(command.equalsIgnoreCase("toggleRadians")){
                trig.toggleDataType();
            }
            else if(command.equalsIgnoreCase("toggleFormat")){
                display.toggleDisplayType(x);
            }
            else if(command.equalsIgnoreCase("MRC")){
                x = memory.getSavedNumber();
                System.out.println(x);
            }
            else if(command.equalsIgnoreCase("M+")){
                memory.saveNumber(x);
            }
            else if(command.equalsIgnoreCase("MC")){
                memory.clearSavedNumber();
            }
            else if(command.equalsIgnoreCase("clear")){
                System.out.println(0);
                System.out.println("Enter a number.");
                x = input.nextDouble();
            }
            else if(command.equalsIgnoreCase("decimal")){
                display.setDecimal(x);   
            }
            else if(command.equalsIgnoreCase("hexadecimal")){
                display.setHexadecimal(x);   
            }
            else if(command.equalsIgnoreCase("octal")){
                display.setOctal(x);   
            }
            else if(command.equalsIgnoreCase("binary")){
                display.setBinary(x);   
            }
            else if(command.equalsIgnoreCase("CToF")){
                double F = display.setCToF(x);
                System.out.println(F + "degrees Fahrenheit");
            }
            else if(command.equalsIgnoreCase("FToC")){
                double C = display.setFToC(x);
                System.out.println(C + "degrees Celcius");
            }
            else if(command.equalsIgnoreCase("help")){
                System.out.println("Vaild commands:\nBasic\nScientific\nConvert\nMemory\nClear\nExit");
            }
            else if(command.equalsIgnoreCase("basic")){
                System.out.println("Basic commands:\nAdd\nSubtract\nMultiply\nDivide\nSwitchSigns");
            }
            else if(command.equalsIgnoreCase("Scientific")){
                System.out.println("Scientific commands:\nSquare\nSqrt\nExponentiation\nInverse\nSine\nCosine\nTangent\nInverseSine\nInverseCosine\nInverseTangent");
            }
            else if(command.equalsIgnoreCase("Convert")){
                System.out.println("Conversions commands:\ntoggleFormat\ntoggleRadians\ndecimal\nhexadecimal\noctal\nbinary\nCToF\nFToC");
            }
            else if(command.equalsIgnoreCase("Memory")){
                System.out.println("Memory commands:\nMRC\nM+\nMC");
            }
            else{
                System.out.println("Invalid command. Enter 'help' for a list of valid commands.");
            }
        }
    }
}
